/** @file install.c
 *  @brief Defines where LC3 OS files are located
 *  @details Allows install location to be changed without recompiling
 *  the lc3sim.c file. Thus, code can be provided as an archive instead of
 *  as source.
 * @author Fritz Sieker
 */

#define INSTALL_DIR "abs_path_to_install_dir" /**< change as necessary */

const char *lc3os_obj = INSTALL_DIR "/lc3os.obj"; /**< path to .obj file */
const char *lc3os_sym = INSTALL_DIR "/lc3os.sym"; /**< path to .sym file */

